/*
 * Name: kstat syscalls.c
 * Date: Sun Feb 10 02:49:49 CET 2002
 * Author: FuSyS [fusys@s0ftpj.org, fusys@sikurezza.org]
 *
 * SoftProject Digital Security for Y2K
 * Sikurezza.org - Italian Security Mailinglist
 *
 * MOJITO-WARE LICENSE - This source code is like "THE BEER-WARE LICENSE" by
 * Poul-Henning Kamp <phk@FreeBSD.ORG> but you can give me in return a mojito.
 *
 * Tested on: Slackware 8 Linux MaNTRa 2.4.16 #4 i686 unknown
 */

#include "linux.h"
#include "syscall.h"

unsigned long *kmem_call_table[256];
unsigned int kaddr;

void show_syscalls(int replace)
{
	int kd, kd2, i, w=0;

	kaddr=find_kmem_offset(SYSCALL);
	kd=open(KMEM, O_RDONLY);
	if(kread(kd, (unsigned long)kaddr, &kmem_call_table, sizeof(kmem_call_table)) == -1) err("kread error");

	if(replace){
		printf("\nRestoring system calls addresses...\n\n");
		kd2=open(KMEM, O_WRONLY);
		if(kwrite(kd2, (unsigned long)kaddr, &calls, sizeof(calls)) == -1) err("kwrite error");
		return;
	}

	for(i=1; i < 256; i++)
		if(kmem_call_table[i]){
			if((unsigned long)kmem_call_table[i] != calls[i] && calls[i] != 0xffffffff && calls[i] != calls[0]){
				printf("\nsys_%-22s%16p", names[i], (void*)kmem_call_table[i]);
				printf(" WARNING! should be at %p", (void*)calls[i]);
				w++;
			}
		}
	if(!w) printf("\nNo System Call Address Modified\n");
	printf("\n");
}

void fingerprint_syscalls()
{
        int kd, i, x, w=0;
	char new_fingerp[FPRINT_SIZE];

	printf("\nProbing System Calls FingerPrints...");
	kaddr=find_kmem_offset(SYSCALL);
	kd=open(KMEM, O_RDONLY);
	if(kread(kd, (unsigned long)kaddr, &kmem_call_table, sizeof(kmem_call_table)) == -1) err("kread error");
	for(i=1; i < 256; i++){
	   if(kmem_call_table[i]){
		if(kread(kd, (unsigned long)kmem_call_table[i], &new_fingerp, sizeof(new_fingerp)) == -1)
			err("kread error");
		if(strstr(new_fingerp, fingerprints[i]) == NULL) {
			w++;
			printf("\nWARNING! sys_%s modified:\n\t<", names[i]);
			for(x=0; x < FPRINT_SIZE; x++)
				printf("\\x%x", new_fingerp[x]&0x000000ff);
			printf("> instead of <");
			for(x=0; x < FPRINT_SIZE; x++)
                                printf("\\x%x", fingerprints[i][x]&0x000000ff);
			printf(">\n");
		}
	   }
	}
	if(!w)printf(" No System Call Modified!\n");
	printf("\n");
}













